/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/// <reference path="api.d.ts" />

namespace API.Client {
    'use strict';

    export interface InlineResponse20014 {

        /**
         * 
         */
        "id": number;

        /**
         * 
         */
        "status": string;

        /**
         * 
         */
        "unmovable": string;

        /**
         * Включен (активен), если true.
         */
        "online": string;

        /**
         * Удален, если true. Данные могут сохраняться.
         */
        "deleted": string;

        /**
         * Удален, если true. Данные могут сохраняться.
         */
        "deletedAuto": string;

        /**
         * 
         */
        "deletedDump": string;

        /**
         * 
         */
        "userId": string;

        /**
         * 
         */
        "ftpId": string;

        /**
         * 
         */
        "dnsId": string;

        /**
         * 
         */
        "iisId": string;

        /**
         * 
         */
        "iisBinding": string;

        /**
         * 
         */
        "iisPath": string;

        /**
         * Уникальное строковое имя сайта (ID).
         */
        "iisComments": string;

        /**
         * 
         */
        "memo": string;

        /**
         * Дата создания.
         */
        "dateReg": string;

        /**
         * Тип веб-сервера.
         */
        "server": string;

        /**
         * 
         */
        "serverBak": string;

        /**
         * 
         */
        "serverAux": string;

        /**
         * Тип сервера недавно изменялся, если true.
         */
        "serverTransition": string;

        /**
         * 
         */
        "serverTransitionDtc": string;

        /**
         * 
         */
        "blockTransfer": string;

        /**
         * 
         */
        "serverChangedTime": string;

        /**
         * Размер веб-сайта - объем (Кб).
         */
        "sizeAmount": string;

        /**
         * Размер веб-сайта - кол-во файлов.
         */
        "sizeFileCount": string;

        /**
         * 
         */
        "sizeFileCountLimit": string;

        /**
         * Размер веб-сайта - дата замера.
         */
        "sizeDate": string;

        /**
         * 
         */
        "sizePriorityScan": string;

        /**
         * 
         */
        "copyLogs": string;

        /**
         * 
         */
        "contentComments": string;

        /**
         * 
         */
        "contentCommentsVerbose": string;

        /**
         * 
         */
        "metaSaveCount": string;

        /**
         * 
         */
        "baseFolder": string;

        /**
         * 
         */
        "virtualhostConf": string;

        /**
         * 
         */
        "virtualhostServer": string;

        /**
         * 
         */
        "virtualhostServerConf": string;

        /**
         * 
         */
        "liveDayCount": string;

        /**
         * 
         */
        "scanDate": string;

        /**
         * 
         */
        "globalTransferCount": string;

        /**
         * 
         */
        "netLimitFile": string;

        /**
         * 
         */
        "netLimitDenyFromIp": string;

        /**
         * 
         */
        "netLimitDenyFromAgent": string;

        /**
         * 
         */
        "apachePhpPooled": string;

        /**
         * 
         */
        "apachePhpPooledExt": string;

        /**
         * 
         */
        "apachePhpPooledExtAuto": string;

        /**
         * 
         */
        "apachePhpPool1Only": string;

        /**
         * 
         */
        "apachePhpPool5Only": string;

        /**
         * 
         */
        "apacheSsi": string;

        /**
         * 
         */
        "bypassSecurity": string;

        /**
         * 
         */
        "flagGenericExec": string;

        /**
         * 
         */
        "flagNoWww": string;

        /**
         * 
         */
        "baseFolderSuffix": string;

        /**
         * 
         */
        "feedbackSpeed": string;

        /**
         * 
         */
        "feedbackSpeedDtc": string;

        /**
         * 
         */
        "feedbackSpeedFeedback": string;

        /**
         * 
         */
        "unixPathOnWindows": string;

        /**
         * Ограничение по IP адресам - FTP доступ.
         */
        "ftpIpfilter": string;

        /**
         * Ограничение по IP адресам - SSH доступ.
         */
        "sshIpfilter": string;

        /**
         * 
         */
        "l3dAuto": string;

        /**
         * 
         */
        "awstatsPrimaryDomain": string;

        /**
         * 
         */
        "sharepointMode": string;

        /**
         * 
         */
        "sharepointModePending": string;

        /**
         * 
         */
        "apacheGenericPoolPort": string;

        /**
         * 
         */
        "mongrelEnvironment": string;

        /**
         * 
         */
        "flagFree": string;

        /**
         * 
         */
        "rtmScanDate": string;

        /**
         * 
         */
        "analyzeAnalog": string;

        /**
         * Включен режим предоставления детализации процессорной нагрузки.
         */
        "cpuDetailsEnabled": string;

        /**
         * 
         */
        "contentModeratedStatus": string;

        /**
         * 
         */
        "contentModeratedDate": string;

        /**
         * 
         */
        "httpFrontendIp": string;

        /**
         * 
         */
        "httpFrontendIpTransition": string;

        /**
         * Дата последнего превышения процессорной нагрузки.
         */
        "cpuLimitExceededDate": string;

        /**
         * Признак сайта-конструктора.
         */
        "aufsTemplate": string;

        /**
         * 
         */
        "optionsAutolimit": string;

        /**
         * Версия ASP.NET, если отлична от 2.0.
         */
        "iisCreationCommands": string;

        /**
         * 
         */
        "iisCreationCommandsUnix": string;

        /**
         * 
         */
        "thumbDate": string;

        /**
         * 
         */
        "thumbFailed": string;

        /**
         * 
         */
        "backupStatDate": string;

        /**
         * Дата пофайловой резервной копии.
         */
        "backupDate": string;

        /**
         * 
         */
        "detectedPackages": string;

        /**
         * 
         */
        "statSitePower": string;

        /**
         * 
         */
        "smtpFrom": string;

        /**
         * 
         */
        "superBackupDate": string;

        /**
         * 
         */
        "backupDeltaStatDate": string;

        /**
         * Дата архивной резервной копии.
         */
        "backupDeltaDate": string;

        /**
         * Содержимое архивной резервной копии.
         */
        "backupDeltaDesc": string;

        /**
         * 
         */
        "altDocrootServer": string;

        /**
         * 
         */
        "altDocrootPath": string;

        /**
         * 
         */
        "altDocrootStatus": string;

        /**
         * 
         */
        "altDocrootStatusCnt": string;

        /**
         * 
         */
        "altDocrootStatusDate": string;

        /**
         * Последнее изменение привязок доменов для сайта.
         */
        "bindDtc": string;

        /**
         * 
         */
        "backupSpecialMode": string;

        /**
         * 
         */
        "sizeCheckProblem": string;

        /**
         * 
         */
        "wpbDomain": string;

        /**
         * Для сайта включен конструктор Parallels WPB.
         */
        "wpbUuid": string;

        /**
         * 
         */
        "wpbStatus": string;

        /**
         * 
         */
        "adminProtection": string;

        /**
         * 
         */
        "sizeComments": string;

        /**
         * 
         */
        "altDocrootSsdReq": string;

        /**
         * 
         */
        "mailLimit": string;

        /**
         * 
         */
        "mailAccept": string;

        /**
         * 
         */
        "mailDrop": string;

        /**
         * FTP/SSH/SCP/SFTP логин.
         */
        "ftpName": string;

        /**
         * FTP/SSH/SCP/SFTP пароль.
         */
        "ftpPwd": string;
    }

}
