/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/// <reference path="api.d.ts" />

/* tslint:disable:no-unused-variable member-ordering */

namespace API.Client {
    'use strict';

    export class VDSHyperVOpenVZApi {
        protected basePath = 'https://www.1gb.ru/api';
        public defaultHeaders : any = {};

        static $inject: string[] = ['$http', '$httpParamSerializer', 'basePath'];

        constructor(protected $http: ng.IHttpService, protected $httpParamSerializer?: (d: any) => any, basePath?: string) {
            if (basePath !== undefined) {
                this.basePath = basePath;
            }
        }

        private extendObj<T1,T2>(objA: T1, objB: T2) {
            for(let key in objB){
                if(objB.hasOwnProperty(key)){
                    objA[key] = objB[key];
                }
            }
            return <T1&T2>objA;
        }

        /**
         * Изменение параметров VDS
         * Изменение параметров уже существующего VDS
         * @param token_ Ключ доступа, полученный при авторизации
         * @param type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
         * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
         * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
         * @param crHvcpu Количество ядер CPU. По умолчанию 2
         * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
         * @param forceMemo 
         * @param hv1gbPanelVersion 
         * @param panelInstall Необходимо ли установить панель 1Gb на VDS
         * @param crSsd1 Создать всю систему на SSD
         * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
         */
        public vdsCreateGet (token_: string, type?: string, crHvmem?: number, crHvdsk?: number, crHvcpu?: number, template?: string, forceMemo?: string, hv1gbPanelVersion?: string, panelInstall?: boolean, crSsd1?: boolean, crHvAllSystem?: boolean, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/create';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsCreateGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (type !== undefined) {
                queryParameters['type'] = type;
            }

            if (crHvmem !== undefined) {
                queryParameters['cr_hvmem'] = crHvmem;
            }

            if (crHvdsk !== undefined) {
                queryParameters['cr_hvdsk'] = crHvdsk;
            }

            if (crHvcpu !== undefined) {
                queryParameters['cr_hvcpu'] = crHvcpu;
            }

            if (template !== undefined) {
                queryParameters['template'] = template;
            }

            if (forceMemo !== undefined) {
                queryParameters['force_memo'] = forceMemo;
            }

            if (hv1gbPanelVersion !== undefined) {
                queryParameters['hv_1gb_panel_version'] = hv1gbPanelVersion;
            }

            if (panelInstall !== undefined) {
                queryParameters['panel_install'] = panelInstall;
            }

            if (crSsd1 !== undefined) {
                queryParameters['cr_ssd1'] = crSsd1;
            }

            if (crHvAllSystem !== undefined) {
                queryParameters['cr_hv_all_system'] = crHvAllSystem;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Удаление VDS
         * Предоставляет функционал для удаления VDS
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         * @param forceCritical Если true, VDS будет удален срочно
         */
        public vdsDeleteGet (token_: string, key_: number, forceCritical?: boolean, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/delete';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsDeleteGet.');
            }
            // verify required parameter 'key_' is not null or undefined
            if (key_ === null || key_ === undefined) {
                throw new Error('Required parameter key_ was null or undefined when calling vdsDeleteGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            if (forceCritical !== undefined) {
                queryParameters['force_critical'] = forceCritical;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Добавление IP на VDS
         * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         */
        public vdsIpAddGet (token_: string, key_: number, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/ip/add';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsIpAddGet.');
            }
            // verify required parameter 'key_' is not null or undefined
            if (key_ === null || key_ === undefined) {
                throw new Error('Required parameter key_ was null or undefined when calling vdsIpAddGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Удаление IP с VDS
         * Этот вызов позволяет отвязать IP адрес от VDS
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         * @param delIp IP адрес, который необходимо удалить
         */
        public vdsIpDeleteGet (token_: string, key_: number, delIp: string, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/ip/delete';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsIpDeleteGet.');
            }
            // verify required parameter 'key_' is not null or undefined
            if (key_ === null || key_ === undefined) {
                throw new Error('Required parameter key_ was null or undefined when calling vdsIpDeleteGet.');
            }
            // verify required parameter 'delIp' is not null or undefined
            if (delIp === null || delIp === undefined) {
                throw new Error('Required parameter delIp was null or undefined when calling vdsIpDeleteGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            if (delIp !== undefined) {
                queryParameters['del_ip'] = delIp;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Список IP-адресов виртуальных серверов
         * Список IP-адресов виртуальных серверов
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         */
        public vdsIpListGet (token_: string, key_?: number, extraHttpRequestParams?: any ) : ng.IHttpPromise<Array<InlineResponse20011>> {
            const localVarPath = this.basePath + '/vds/ip/list';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsIpListGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Список виртуальных серверов
         * Позволяет получить список виртуальных серверов
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
         */
        public vdsListGet (token_: string, key_?: number, extraHttpRequestParams?: any ) : ng.IHttpPromise<Array<InlineResponse20012>> {
            const localVarPath = this.basePath + '/vds/list';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsListGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Перезагрузка VDS
         * Предоставляет функционал для перезагрузки VDS
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         */
        public vdsRebootGet (token_: string, key_: number, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/reboot';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsRebootGet.');
            }
            // verify required parameter 'key_' is not null or undefined
            if (key_ === null || key_ === undefined) {
                throw new Error('Required parameter key_ was null or undefined when calling vdsRebootGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Список шаблонов виртуальных серверов
         * Позволяет получить список шаблонов виртуальных серверов
         * @param token_ Ключ доступа, полученный при авторизации
         */
        public vdsTemplatesListGet (token_: string, extraHttpRequestParams?: any ) : ng.IHttpPromise<Array<InlineResponse20013>> {
            const localVarPath = this.basePath + '/vds/templates-list';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsTemplatesListGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
        /**
         * Создание VDS
         * Создание новых VDS с произвольными характеристиками
         * @param token_ Ключ доступа, полученный при авторизации
         * @param key_ ID виртуального сервера, полученный из /vds/list
         * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
         * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
         * @param crHvcpu Количество ядер CPU. По умолчанию 2
         */
        public vdsUpdateGet (token_: string, key_: number, crHvmem?: number, crHvdsk?: number, crHvcpu?: number, extraHttpRequestParams?: any ) : ng.IHttpPromise<string> {
            const localVarPath = this.basePath + '/vds/update';

            let queryParameters: any = {};
            let headerParams: any = this.extendObj({}, this.defaultHeaders);
            // verify required parameter 'token_' is not null or undefined
            if (token_ === null || token_ === undefined) {
                throw new Error('Required parameter token_ was null or undefined when calling vdsUpdateGet.');
            }
            // verify required parameter 'key_' is not null or undefined
            if (key_ === null || key_ === undefined) {
                throw new Error('Required parameter key_ was null or undefined when calling vdsUpdateGet.');
            }
            if (token_ !== undefined) {
                queryParameters['_token_'] = token_;
            }

            if (key_ !== undefined) {
                queryParameters['_key_'] = key_;
            }

            if (crHvmem !== undefined) {
                queryParameters['cr_hvmem'] = crHvmem;
            }

            if (crHvdsk !== undefined) {
                queryParameters['cr_hvdsk'] = crHvdsk;
            }

            if (crHvcpu !== undefined) {
                queryParameters['cr_hvcpu'] = crHvcpu;
            }

            let httpRequestParams: any = {
                method: 'GET',
                url: localVarPath,
                json: true,
                                                params: queryParameters,
                headers: headerParams
            };

            if (extraHttpRequestParams) {
                httpRequestParams = this.extendObj(httpRequestParams, extraHttpRequestParams);
            }

            return this.$http(httpRequestParams);
        }
    }
}
